function AFNumber_Keystroke(nDec, sepStyle, negStyle, currStyle, strCurrency, bCurrencyPrepend)
{
    //NOT IMPLEMENTED
    event.rc= false;
}


function AFSimple_Calculate(cFunction, cFields)
{
    if(cFunction=="SUM")
    {
        var sum= 0;
        for(var i= 0; i<cFields.length; i++)
        {
            var val = event.target.doc.getField(cFields[i]).value;
             sum+= new Number(val);
        }
        
        event.value= sum;
        return;
    }
    
    throw new Error("AFSimple_Calculate(" + cFunction + "...) is not implemented");
}

function AFMakeNumber(val){
    return new Number(val);
}


function AFNumber_Format(nDec, sepStyle, negStyle, currStyle, strCurrency, bCurrencyPrepend)
{
    var num= AFMakeNumber(event.value);
    
    var res= num.toFixed(2);
    
    if(bCurrencyPrepend)
        res= strCurrency + res;
    else
        res= res + strCurrency;

    event.value= res;
    event.rc= true; 
}

function AFMergeChange(event)
{
	var prefix, postfix;
	var value = event.value;
	if(event.willCommit) return event.value;
	if(event.selStart >= 0)
		prefix = value.substring(0, event.selStart);
	else
		prefix = "";
	if(event.selEnd >= 0 && event.selEnd <= value.length)
		postfix = value.substring(event.selEnd, value.length);
	else
		postfix = "";
	return prefix + event.change + postfix;
}

function AFExtractNums(string)
{
	if(!string)
		return null;

	var nums = new Array();
	var inNum= false;
	for(pos= 0; pos<string.length; pos++)
	{
		var ch= string.charAt(pos);
		if(ch>='0' && ch<='9')
		{
			if(!inNum){
				inNum= true;
				nums.length++;
				nums[nums.length-1]=ch-'0';
			}
			else
			{	
				nums[nums.length-1]*=10;
				nums[nums.length-1]+=ch-'0';
			}
		}
		else
			inNum= false;
	}

	if(nums.length >= 1) 
		return nums;
	return null;
}

function AFParseDateEx(cDate, cFormat)
{
	
	var posY= -1;
	var lenY= 0;
	var posD= -1;
	var lenD= 0;
	var posM= -1;
	var lenM= 0;

	var component= 0;
	for(pos= 0; pos<cFormat.length; pos++){
		switch(cFormat.charAt(pos))
		{
		case 'y':
			if(posY<0)
				posY= component++;
			lenY++;
			break;
		case 'm':
			if(posM<0)
				posM= component++;
			lenM++;
			break;
		case 'd':
			if(posD<0)
				posD= component++;
			lenD++;
			break;
		}
	}
	
	var nums= AFExtractNums(cDate);
	if(!nums)
		return nums;
	
	if(posY<0 || posY>2)
		return;
	var year= nums[posY];
	if(year<100)
		year+=2000;

	if(posM<0 || posM>2)
		return;
	var month= nums[posM];
	if(month<1 || month>12)
		return null;
	
	if(posD>2)
		return;
	var day= 1;
	if(posD>=0)
		day= nums[posD];

	if(day<1 || day>31)
		return null;
	
	switch(month){
		case 4:
		case 6:
		case 9:
		case 11:
			if(day>30)
				return null;
			break;
		case 2:
			if(day>29)
				return null;
			if(day==29 && !((year%400)==0 || ((year%4)==0 && (year%100)!=0 ))){
					return null;
			}
			break;
	}
	
	//TODO: fix valid days in short months
	
	var date= new Date(year, month-1, day);
	if(isNaN(date.getTime()))
		return null;
	return date;
}

function AFDate_FormatEx(cFormat)
{
	if (!event.value) 
		return;	/* Blank fields remain blank */

	var date = AFParseDateEx(event.value, cFormat);
	if (!date) {
		event.value = "";
		return;
	}
	
	event.value = util.printd(cFormat, date);
}